<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/31/2003 *
 * ===============                              Last change: 08/02/2003 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : holiday_functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Functions for the admins extension               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die admins-Erweiterung           *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
function HOLIDAY_STOP_HOLIDAYS () {
	// Let's find some expired holiday requests...
	$result_stop = SQL_QUERY("SELECT userid, holiday_start, holiday_end, comments
FROM "._MYSQL_PREFIX."_user_holidays
WHERE holiday_end <= UNIX_TIMESTAMP()
ORDER BY userid", __FILE__, __LINE__);
	if (SQL_NUMROWS($result_stop) > 0) {
		// We foud at least one
		$admin = "";
		while (list($uid, $start, $end, $comments) = SQL_FETCHROW($result_stop)) {
			// Stop holiday
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_user_holidays WHERE userid=%s LIMIT 1",
				array(bigintval($uid)), __FILE__, __LINE__);

			// Unlock account
			SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_user_data
SET holiday_active='N', holiday_activated='0'
WHERE userid=%s LIMIT 1", array(bigintval($uid)), __FILE__, __LINE__);

			// Prepare array
			$content = array(
				'holiday_end'      => MAKE_DATETIME($end  , "3"),
				'holiday_start'    => MAKE_DATETIME($start, "3"),
				'holiday_comments' => $comments
			);

			// Send mail to user
			$msg = LOAD_EMAIL_TEMPLATE("member_holiday_unlock", $content, $uid);
			SEND_EMAIL($uid, HOLIDAY_MEMBER_UNLOCK_SUBJ, $msg);

			// Remember userid for admin
			$admin .= $uid."\n";
		}

		// Send mail to admins
		SEND_ADMIN_NOTIFICATION(HOLIDAY_ADMIN_UNLOCK_SUBJ, "admin_holiday_unlock", $admin, "0");
	}

	// Free memory
	SQL_FREERESULT($result_stop);
}

//
?>
